#include<bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2,bmi,bmi2")
#define all(a) a.begin(),a.end()
#define int long long
using namespace std;
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    int n;
    cin >> n;
    int m;
    cin >> m;
    int a[n + 1];
    set<int>s;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        s.insert((a[i] & 1));
    }
    if (s.size() == 1) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
        exit(0);
    }
    if (t == 1) {
        exit(0);
    }
    cout << (m + 1) / 2 << endl;
    if (t == 2) {
        exit(0);
    }
    cout << 1 << endl;
    cout << m << ' ' << (m + 1) / 2 << endl;
}